## veryfasttree 4.0.1+dfsg

=== debian/changelog ===
veryfasttree (4.0.1+dfsg-2) unstable; urgency=medium

  * Team upload.
  * Fix license

 -- Andreas Tille <tille@debian.org>  Thu, 20 Jul 2023 16:43:36 +0200

veryfasttree (4.0.1+dfsg-1) unstable; urgency=low

  * Initial release (Closes: #1038668)

 -- César Pomar <cesaralfredo.pineiro@usc.es>  Tue, 11 Jul 2023 15:53:44 +0200

=== debian/rules ===
#!/usr/bin/make -f

# Output every command that modifies files on the build system.
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
include /usr/share/dpkg/default.mk

%:
	dh $@


override_dh_auto_configure:
ifeq (amd64,$(DEB_HOST_ARCH))
	for i in "sse2 SEE2" "sse4_1 SEE4" "avx AVX" "avx2 AVX2" "avx512f AVX512" ; do \
		set -- $${i} ; \
		dh_auto_configure --builddirectory build_$${1} -- \
			-DUSE_NATIVE=OFF -DUSE_SHARED=ON -DUSE_$${2}=ON ; \
	done
else
	dh_auto_configure -- \
		-DUSE_NATIVE=OFF -DUSE_SHARED=ON
endif


override_dh_auto_build:
ifeq (amd64,$(DEB_HOST_ARCH))
	for SIMD in avx512f avx2 avx sse4_1 sse2 ; do \
		dh_auto_build --builddirectory build_$${SIMD} && \
		mv build_$${SIMD}/VeryFastTree build_$${SIMD}/VeryFastTree-$${SIMD} ; \
	done
	mkdir -p build_simd
	cp debian/bin/VeryFastTree-simd build_simd/VeryFastTree
else
	dh_auto_build
endif


override_dh_auto_install:
ifeq (amd64,$(DEB_HOST_ARCH))
	dh_install build_*/VeryFastTree* /usr/bin/
else
	dh_auto_install
endif

override_dh_auto_clean:
	dh_auto_clean
	rm -Rf build_*

## veryfasttree 4.0.3+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(VeryFastTree)

set(CMAKE_CXX_STANDARD 11)

option(USE_SHARED "enable/disable linking of system shared libraries" OFF)
option(USE_NATIVE "enable/disable system's processor architecture optimization (linux)" ON)
option(USE_SEE2 "enable/disable SSE2 in windows (linux default)" ON)
option(USE_SEE4 "enable/disable SSE4.1" OFF)
option(USE_AVX "enable/disable AVX" OFF)
option(USE_AVX2 "enable/disable AVX2" OFF)
option(USE_AVX512 "enable/disable AVX512" OFF)
option(USE_CUDA "enable/disable CUDA" OFF)
set(CUDA_ARCH "80" CACHE STRING "change CUDA Architecture")

add_definitions(-DCLI11_BOOST_OPTIONAL=0)
add_definitions(-DNDEBUG)

ADD_SUBDIRECTORY("libs/CLI11")
ADD_SUBDIRECTORY("libs/bxzstr")
if (USE_SHARED AND NOT MSVC)
    set(LIBRARIES z bz2)
else ()
    ADD_SUBDIRECTORY("libs/boost-align")
    ADD_SUBDIRECTORY("libs/boost-core")
    ADD_SUBDIRECTORY("libs/boost-sort")
    ADD_SUBDIRECTORY("libs/bzip2")
    ADD_SUBDIRECTORY("libs/zlib")
    ADD_SUBDIRECTORY("libs/robin-map")
    ADD_SUBDIRECTORY("libs/xxhash")
    set(LIBRARIES boost-core boost-sort boost-align robin_map xxhash zlibstatic bzip2static)
endif ()

set(LIBRARIES CLI11 bxzstr ${LIBRARIES} )

set(SOURCE_FILES
        src/operations/BasicOperations.tcc
        src/operations/BasicOperations.h
        src/operations/SSE128Operations.tcc
        src/operations/SSE128Operations.h
        src/operations/AVX256Operations.tcc
        src/operations/AVX256Operations.h
        src/operations/AVX512Operations.tcc
        src/operations/AVX512Operations.h
        src/impl/VeryFastTreeDouble.cpp
        src/impl/VeryFastTreeDoubleAVX256.cpp
        src/impl/VeryFastTreeDoubleAVX512.cpp
        src/impl/VeryFastTreeDoubleCuda.cpp
        src/impl/VeryFastTreeDoubleSSE128.cpp
        src/impl/VeryFastTreeFloat.cpp
        src/impl/VeryFastTreeFloatAVX256.cpp
        src/impl/VeryFastTreeFloatAVX512.cpp
        src/impl/VeryFastTreeFloatCuda.cpp
        src/impl/VeryFastTreeFloatSSE128.cpp
        src/Knuth.cpp
        src/Knuth.h
        src/Options.h
        src/Constants.h
        src/Debug.h
        src/DiskMemory.cpp
        src/DiskMemory.h
        src/Utils.h
        src/HashTable.h
        src/DistanceMatrix.tcc
        src/DistanceMatrix.h
        src/TransitionMatrix.tcc
        src/TransitionMatrix.h
        src/NeighbourJoining.tcc
        src/NeighbourJoining.h
        src/Alignment.cpp
        src/Alignment.h
        src/VeryFastTreeImpl.tcc
        src/VeryFastTree.cpp
        src/VeryFastTree.h
        main.cpp
        )

if (USE_CUDA)
    message("WARNING!! CUDA is only a experimental feature")
    set(CMAKE_CUDA_ARCHITECTURES ${CUDA_ARCH})
    set(USE_CUDA 1)
    enable_language(CUDA)
    find_package(CUDAToolkit)
    set(SOURCE_FILES
            ${SOURCE_FILES}
            src/operations/CudaOperations.h
            src/operations/CudaOperations.cu
            )

    set(LIBRARIES ${LIBRARIES} CUDA::cublas)
else ()
    set(USE_CUDA 0)
endif ()

if (MSVC)
    ADD_SUBDIRECTORY("libs/mman-win32")
    set(LIBRARIES ${LIBRARIES} mman-win32)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W2 /O2 /EHsc /bigobj /DUSE_CUDA=${USE_CUDA}")
    if (USE_AVX512)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /arch:AVX512 /D__AVX512F__=1 /D__AVX2__=1 /D__AVX__=1")
    elseif (USE_AVX2)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /arch:AVX2 /D__AVX2__=1 /D__AVX__=1")
    elseif (USE_AVX)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /arch:AVX /D__AVX__=1")
    elseif (USE_SEE4)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /arch:SSE2 /D__SSE4_1__=1 /D__SSE2__=1")
    elseif (USE_SEE2)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /arch:SSE2 /D__SSE2__=1")
    endif ()
else ()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -O3 -DUSE_CUDA=${USE_CUDA}")
    if (USE_AVX512)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mavx512f")
    elseif (USE_AVX2)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mavx2")
    elseif (USE_AVX)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mavx")
    elseif (USE_SEE4)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse4.1")
    endif ()
    if (USE_NATIVE)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=native")
    endif ()
endif ()

find_package(OpenMP)
if(NOT TARGET OpenMP::OpenMP_CXX)
    find_package(Threads REQUIRED)
    add_library(OpenMP::OpenMP_CXX IMPORTED INTERFACE)
    set_property(TARGET OpenMP::OpenMP_CXX PROPERTY INTERFACE_COMPILE_OPTIONS ${OpenMP_CXX_FLAGS})
    set_property(TARGET OpenMP::OpenMP_CXX PROPERTY INTERFACE_LINK_LIBRARIES ${OpenMP_CXX_FLAGS} Threads::Threads)
endif()

add_executable(${PROJECT_NAME} ${SOURCE_FILES})
target_link_libraries(${PROJECT_NAME} OpenMP::OpenMP_CXX ${LIBRARIES})

install(TARGETS ${PROJECT_NAME} DESTINATION bin)

=== libs/CLI11/CMakeLists.txt ===
project(CLI11)

add_library(CLI11 INTERFACE)

target_include_directories(CLI11 INTERFACE ${CMAKE_CURRENT_SOURCE_DIR}/include)

=== libs/bxzstr/CMakeLists.txt ===
#cmake_minimum_required(VERSION 3.0)
project(bxzstr)


set(BXZSTR_Z_SUPPORT 1)
set(BXZSTR_BZ2_SUPPORT 1)
set(BXZSTR_LZMA_SUPPORT 0)
set(BXZSTR_ZSTD_SUPPORT 0)


configure_file(include/config.hpp.in ${CMAKE_CURRENT_SOURCE_DIR}/include/config.hpp @ONLY)

add_library(bxzstr INTERFACE)
target_include_directories(bxzstr INTERFACE include)

=== debian/changelog ===
veryfasttree (4.0.3+dfsg-1) unstable; urgency=medium

  * 32 bits compatible version
  * baseline-specific executables moved out of the path to libexec

 -- César Pomar <cesaralfredo.pineiro@usc.es>  Tue, 12 Sep 2023 20:02:05 +0200

=== debian/control ===
Source: veryfasttree
Section: science
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: César Pomar <cesaralfredo.pineiro@usc.es>
Build-Depends: debhelper-compat (= 13),
               cmake,
               libboost-dev,
               libbz2-dev,
               robin-map-dev,
               libxxhash-dev,
               zlib1g-dev
Standards-Version: 4.6.2
Homepage: https://github.com/citiususc/veryfasttree
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/med-team/veryfasttree.git
Vcs-Browser: https://salsa.debian.org/med-team/veryfasttree

Package: veryfasttree
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends},
	 ${shlibs:Depends}
Description: Speeding up the estimation of phylogenetic trees from sequences
 VeryFastTree is a highly efficient implementation inspired by the FastTree-2
 tool, designed to expedite the inference of approximately-maximum-likelihood
 phylogenetic trees from nucleotide or protein sequence alignments. It is an
 optimized implementation designed to accelerate the estimation of phylogenies
 for large alignments. By leveraging parallelization and vectorization
 strategies, VeryFastTree significantly improves the performance and
 scalability of phylogenetic analysis, allowing it to construct phylogenetic
 trees in a fraction of the time previously required.
 .
 Maintaining the integrity of FastTree-2, VeryFastTree retains the same phases,
 methods, and heuristics used for estimating phylogenetic trees. This ensures
 that the topological accuracy of the trees produced by VeryFastTree remains
 equivalent to that of FastTree-2. Moreover, unlike the parallel version of
 FastTree-2, VeryFastTree guarantees deterministic results, eliminating any
 potential variations in the output.
 .
 To facilitate a seamless transition for users, VeryFastTree adopts the exact
 same command line arguments as FastTree-2. This means that by simply
 substituting FastTree-2 with VeryFastTree, and using the same set of options,
 users can significantly enhance the overall performance of their phylogenetic
 analyses.

## veryfasttree 4.0.4%2Bdfsg

=== debian/changelog ===
veryfasttree (4.0.4+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 4.0.4+dfsg
  * d/manpages: use newly introduced manual pages upstream.
  * d/VeryFastTree.1: delete: maintainer manual is now unneeded.
  * d/control: declare compliance to standards version 4.7.0.
  * d/copyright: update upstream copyright years.

 -- Étienne Mollier <emollier@debian.org>  Sat, 02 Nov 2024 17:03:57 +0100

## veryfasttree 4.0.4+dfsg

=== debian/changelog ===
veryfasttree (4.0.4+dfsg-2) unstable; urgency=medium

  * Team upload.
  * d/s/local-options: delete: unused.
  * gcc-15.patch: new: fix build failures with Gcc 15. (Closes: #1098063)
  * d/control: declare compliance to standards version 4.7.2.

 -- Étienne Mollier <emollier@debian.org>  Sun, 06 Apr 2025 17:44:29 +0200

=== debian/watch ===
version=4

opts="repacksuffix=+dfsg,dversionmangle=auto,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
https://github.com/citiususc/veryfasttree/tags (?:.*?/)?v?@ANY_VERSION@\.tar\.gz

## veryfasttree 4.0.5+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.5)
+cmake_minimum_required(VERSION 3.5...3.27)
 project(VeryFastTree)
 
 set(CMAKE_CXX_STANDARD 11)

=== libs/CLI11/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,4 @@
+cmake_minimum_required(VERSION 3.5...3.27)
 project(CLI11)
 
 add_library(CLI11 INTERFACE)

=== libs/bxzstr/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-#cmake_minimum_required(VERSION 3.0)
+cmake_minimum_required(VERSION 3.5...3.27)
 project(bxzstr)

=== debian/changelog ===
veryfasttree (4.0.5+dfsg-2) unstable; urgency=medium

  * Team upload.
  * robin_map.patch: new: bump to stdc++17.
    This fixes build failure with robin_map 1.4.0. (Closes: #1118378)
  * d/watch: convert to Github template for watch file v5.
  * d/control: drop redundant Rules-Requires-Root: no.

 -- Étienne Mollier <emollier@debian.org>  Fri, 24 Oct 2025 20:37:22 +0200

veryfasttree (4.0.5+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 4.0.5+dfsg
  * gcc-15.patch: delete: applied upstream.

 -- Étienne Mollier <emollier@debian.org>  Wed, 13 Aug 2025 21:32:04 +0200

=== debian/control ===
--- 
+++ 
@@ -10,9 +10,8 @@
                robin-map-dev,
                libxxhash-dev,
                zlib1g-dev
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Homepage: https://github.com/citiususc/veryfasttree
-Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/med-team/veryfasttree.git
 Vcs-Browser: https://salsa.debian.org/med-team/veryfasttree

=== debian/rules ===
--- 
+++ 
@@ -38,7 +38,8 @@
 
 override_dh_auto_install:
 ifeq (amd64,$(DEB_HOST_ARCH))
-	dh_install build_*/VeryFastTree* /usr/bin/
+	dh_install build_*/VeryFastTree-* /usr/libexec/VeryFastTree/
+	dh_install build_*/VeryFastTree /usr/bin/
 else
 	dh_auto_install
 endif

=== debian/watch ===
Version: 5

Template: Github
Owner: citiususc
Project: veryfasttree
Dversionmangle: auto
Repacksuffix: +dfsg
